=begin
(c) TIG 2009
load"selectedfaces2components.rb";selectedfaces2components
=end
require 'sketchup.rb'
###
def selectedfaces2components()
    model=Sketchup.active_model
    ss=model.selection
    faces=[]
    ss.each{|e|faces<<e if e.class==Sketchup::Face}
    if not faces[0]
      UI.messagebox("You must select at least one face !")
      return nil
    end#if
    model.start_operation("selectedfaces2components",true)
    ### remove ',true' for <v7
    edges2go=[]
    ### first we 'clone' the faces...
    number=faces.length
    count=1
    faces.each{|face|
      points=[]; face.vertices.each{|v|points<<v.position}
      group=model.active_entities.add_group()
      face2=group.entities.add_face(points)
      face2.reverse! if face2.normal != face.normal
      face2.material=face.material
      face2.back_material=face.back_material
      ### also clone attributes etc - you add this...
      ### also clone materials/attributes of edges etc - you do this...
      g=group.to_component
      g.definition.name="Face#1"
      g.name=g.definition.name
      ### stuff to go...
      edges2go<<face.edges
      face.erase! ### it's now in the group
      Sketchup::set_status_text("Face "+count.to_s+" of "+number.to_s+" made into Component.")
      count+=1
    }
    edges2go.flatten!
    edges2go.uniq!
    edges2go.each{|e|e.erase! if e.valid? and e.faces.length==0}
    Sketchup::set_status_text(number.to_s+" Faces made into Components.")
    model.commit_operation
end#def
